

/**
* This file is part of license combination gpl version 3 license and eCos.
* The corresponding license terms are below.
*
* gpl version 3 Licence:
*
* The file were developed during the student thesis "Datensammlung in Wireless 
* Sensor Networks fuer Autonomic Home Networking of Thomas Kothmayr and is 
* included in the dissertation "Secure Data Transmission in Wireless 
* Sensor Networks" by Corinna Schmitt during employment at the Technische
* Universitt Mnchen, Department Computer Science, Chair Network 
* Architectures and Services (Germany).
* Copyright (C) 2013  
* Authors: Thomas Kothmayr and Corinna Schmitt (schmitt[at]net.in.tum.de)
*
* This program is free software: you can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation, version 3 of the License
* 
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU General Public License for more details.
*
* You should have received a copy of the GNU General Public License
* along with this program.  If not, see <http://www.gnu.org/licenses/>.
*
*
* eCos Licence: (http://ecos.sourceware.org)
*
* This file is part of eCos, the Embedded Configurable Operating System. 
* Copyright (C) 1998, 1999, 2000, 2001, 2002, 2003, 2004, 2005, 2006, 
* 2007, 2008, 2009 Free Software Foundation, Inc. 
*
* eCos is free software; you can redistribute it and/or modify it under 
* the terms of the GNU General Public License as published by the Free 
* Software Foundation; either version 3 any later version. 
* 
* eCos is distributed in the hope that it will be useful, but WITHOUT ANY 
* WARRANTY; without even the implied warranty of MERCHANTABILITY or 
* FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for 
* more details. 
* 
* You should have received a copy of the GNU General Public License along 
* with eCos; if not, write to the Free Software Foundation, Inc., 51 
* Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA. 
*
* As a special exception, if other files instantiate templates or use 
* macros or inline functions from this file, or you compile this file and * link it with other works to produce a work based on this file, this file 
* does not by itself cause the resulting work to be covered by the GNU 
* General Public License. However the source code for this file must still 
* be made available in accordance with section (3) of the GNU General 
* Public License v2. 
* 
* This exception does not invalidate any other reasons why a work based on 
* this file might be covered by the GNU General Public License.
*
*/
package ipfix;

import java.io.StringReader;
import java.util.Stack;

import de.tum.in.net.authone.knowledgeagent.client.IKnowledgeAgentConnector;
import de.tum.in.net.authone.knowledgeagent.common.exceptions.InsufficientCredentialsException;
import de.tum.in.net.authone.knowledgeagent.common.exceptions.InvalidAddressException;

public class Field {
	private String name = "", datatype = "", expression = "";
	private int ID;
	private long enterpriseID;
	private int length;
	private Object value = null;
	private boolean sendout = true;
	private IKnowledgeAgentConnector connector;
	
	public Field(int ID, long enterpriseID, int length){
		this.length = length;
		this.ID = ID;
		this.enterpriseID = enterpriseID;
		
	}
	
	public Field(IKnowledgeAgentConnector connector){
		this.connector = connector;
	}
	
	public Object getValue() {
		return value;
	}
	public void setValue(Object value) {
		this.value = value;
		if(!expression.equals("")){
			try {
				expression = "("+expression.replaceAll("x", value.toString())+")";
				this.value = eval();
			} catch (Exception e) {
				e.printStackTrace();
			}
		}
		if(isSendout() && connector != null){
			try {
				if(name.length() > 0){
					//send data to AutHoNe
					connector.set("WSN/"+name, value);
				}else;
				//send data to AutHoNe
				connector.set("WSN/"+ID+"|"+enterpriseID, value);
			} catch (InvalidAddressException e) {
				e.printStackTrace();
			} catch (InsufficientCredentialsException e) {
				e.printStackTrace();
			}
		}
	}
	public String getName() {
		return name;
	}
	public void setName(String name) {
		this.name = name;
	}
	public String getDatatype() {
		return datatype;
	}
	public void setDatatype(String datatype) {
		this.datatype = datatype;
	}
	public int getID() {
		return ID;
	}
	public void setID(int iD) {
		ID = iD;
	}
	public long getEnterpriseID() {
		return enterpriseID;
	}
	public void setEnterpriseID(long enterpriseID) {
		this.enterpriseID = enterpriseID;
	}
	public int getLength() {
		return length;
	}
	public void setLength(int length) {
		this.length = length;
	}
	public boolean isSendout() {
		return sendout;
	}
	public void setSendout(boolean sendout) {
		this.sendout = sendout;
	}
	public IKnowledgeAgentConnector getConnector() {
		return connector;
	}
	public void setConnector(IKnowledgeAgentConnector connector) {
		this.connector = connector;
	}
	public String getExpression() {
		return expression;
	}
	public void setExpression(String expression) {
		this.expression = expression.trim().toLowerCase();
	}
	private double eval() throws Exception{
        Stack<String> operators  = new Stack<String>();
        Stack<Double> values = new Stack<Double>();
        StringReader reader = new StringReader(expression);
        int val = 0;
        String num = "";
        String s = "";
        while ((val = reader.read())!= -1) {
            s = ""+(char)val;
            if (s.equals("("));
            else if (s.equals("+")){
            	if(num.trim().length() > 0){
            		values.push(Double.valueOf(num));
            		num = "";
            	}
            	operators.push(s);
            }else if (s.equals("-")){
            	if(num.trim().length() > 0){
            		values.push(Double.valueOf(num));
            		num = "";
            	}
            	operators.push(s);
            }else if (s.equals("*")){
            	if(num.trim().length() > 0){
            		values.push(Double.valueOf(num));
            		num = "";
            	}
            	operators.push(s);
            }else if (s.equals("/")){
            	if(num.trim().length() > 0){
            		values.push(Double.valueOf(num));
            		num = "";
            	}
            	operators.push(s);
            }else if (s.equals("s")){
            	if(num.trim().length() > 0){
            		values.push(Double.valueOf(num));
            		num = "";
            	}
            	if((char)reader.read() == 'q' && (char)reader.read() == 'r' && (char)reader.read() == 't')
            		operators.push("sqrt");
            	else{
            		throw new Exception("invalid character sequence");
            	}
            }else if (s.equals("l")){
            	if(num.trim().length() > 0){
            		values.push(Double.valueOf(num));
            		num = "";
            	}
            	if((char)reader.read() == 'n')
            		operators.push("ln");
            	else{
            		throw new Exception("invalid character sequence");
            	}
            }else if (s.equals(")")) {
            	if(num.trim().length() > 0){
            		values.push(Double.valueOf(num));
            		num = "";
            	}
            	if(!operators.empty()){
	                String op = operators.pop();
	                double v = values.pop();
	                if(op.equals("+"))
	                	v = values.pop() + v;
	                else if (op.equals("-"))    
	                	v = values.pop() - v;
	                else if (op.equals("*"))   
	                	v = values.pop() * v;
	                else if (op.equals("/"))    
	                	v = values.pop() / v;
	                else if (op.equals("sqrt")) v = Math.sqrt(v);
	                else if (op.equals("ln")) v = Math.log(v);
	                values.push(v);
            	}
            }
            else num += s;
        }
 
        return values.pop();
	}
}
