

/**
* This file is part of license combination gpl version 3 license and eCos.
* The corresponding license terms are below.
*
* gpl version 3 Licence:
*
* The file were developed during the student thesis "Datensammlung in Wireless 
* Sensor Networks fuer Autonomic Home Networking of Thomas Kothmayr and is 
* included in the dissertation "Secure Data Transmission in Wireless 
* Sensor Networks" by Corinna Schmitt during employment at the Technische
* Universitt Mnchen, Department Computer Science, Chair Network 
* Architectures and Services (Germany).
* Copyright (C) 2013  
* Authors: Thomas Kothmayr and Corinna Schmitt (schmitt[at]net.in.tum.de)
*
* This program is free software: you can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation, version 3 of the License
* 
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU General Public License for more details.
*
* You should have received a copy of the GNU General Public License
* along with this program.  If not, see <http://www.gnu.org/licenses/>.
*
*
* eCos Licence: (http://ecos.sourceware.org)
*
* This file is part of eCos, the Embedded Configurable Operating System. 
* Copyright (C) 1998, 1999, 2000, 2001, 2002, 2003, 2004, 2005, 2006, 
* 2007, 2008, 2009 Free Software Foundation, Inc. 
*
* eCos is free software; you can redistribute it and/or modify it under 
* the terms of the GNU General Public License as published by the Free 
* Software Foundation; either version 3 any later version. 
* 
* eCos is distributed in the hope that it will be useful, but WITHOUT ANY 
* WARRANTY; without even the implied warranty of MERCHANTABILITY or 
* FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for 
* more details. 
* 
* You should have received a copy of the GNU General Public License along 
* with eCos; if not, write to the Free Software Foundation, Inc., 51 
* Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA. 
*
* As a special exception, if other files instantiate templates or use 
* macros or inline functions from this file, or you compile this file and * link it with other works to produce a work based on this file, this file 
* does not by itself cause the resulting work to be covered by the GNU 
* General Public License. However the source code for this file must still 
* be made available in accordance with section (3) of the GNU General 
* Public License v2. 
* 
* This exception does not invalidate any other reasons why a work based on 
* this file might be covered by the GNU General Public License.
*
*/
import java.io.*;
import java.net.*;
class PacketSplitter{
	static int port = 1500;
	/**
	* This little utility reads a stream of IPFIX packages from a file, splits it
	* at the appropriate Message boundaries and sends them to a UDP port.
	*/
	public static void main(String[] args){
		if(args.length < 1){
			System.err.println("Usage: PacketSplitter filename [port]\n Port defaults to 1500");
			return;
		}
		if(args.length > 1){
			try {
				port = Integer.parseInt(args[1]);
			} catch (Exception e) {
				port = 1500;
			}
		}
		
		
		try{
			DataInputStream iofile = new DataInputStream(new FileInputStream(new File(args[0])));
			DatagramSocket clientSocket = new DatagramSocket();
			InetAddress IPAddress = InetAddress.getByName("localhost");

			byte header[] = new byte[4];
			byte packet[];
			while(iofile.read(header,0,4) > 0){
				Integer len = header[2]*256 + header[3];
				packet = new byte[len];
				packet[0] = header[0];
				packet[1] = header[1];
				packet[2] = header[2];
				packet[3] = header[3];
				iofile.read(packet,4,len - 4);
				System.out.println("read a packet of length "+len);
				DatagramPacket sendPacket = new DatagramPacket(packet, len, IPAddress, port);
      			clientSocket.send(sendPacket);
      			Thread.sleep(1000);
			}
			clientSocket.close();

		
		}catch(Exception ex){
			ex.printStackTrace();
		}
	
	}

}
